--Initialize.
MFL 					= {}
MFL.name				= "MiniFriendList"
MFL.version				= 0.41
MFL.lastFriendClicked   = ""
local print             = d


local TimerTable = {}
function DelayedBuffer(key, buffer)
	if key == nil then return end
	if TimerTable[key] == nil then TimerTable[key] = {} end
	TimerTable[key].buffer = buffer or 3
	TimerTable[key].now = GetFrameTimeSeconds()
	if TimerTable[key].last == nil then TimerTable[key].last = TimerTable[key].now end
	TimerTable[key].diff = TimerTable[key].now - TimerTable[key].last
	TimerTable[key].eval = TimerTable[key].diff >= TimerTable[key].buffer
	if TimerTable[key].eval then TimerTable[key].last = TimerTable[key].now end
	return TimerTable[key].eval
end

--Default Saved Variables.
MFL.defaults = {
	--Global.
	["skin"]               = "ZO_DefaultBackdrop",
	["listSize"]           = 7,
	["showOffline"]        = true,
	["autoAccept"]         = false,
		
	--Main Frame.
	["mainFrameMovable"]   = false,
	["mainFramePosition"]  = {0, 0},
	["mainFrameAlpha"]     = 80,
	["mainFrameFont"]      = "ZoFontGame",
	["mainFrameFontAlign"] = "CENTER",
	["mainFrameScale"]     = 80,
	
}

function MFL.Initialize(eventCode, addonName)
	--Only set up for MFL.
	if(addonName ~= MFL.name) then return end
	
	--Load all saved variables.
	MFL.savedVars = ZO_SavedVars:New('MFL_SAVEDVARIABLES_DB' , 102, nil , MFL.defaults)
	
	--LAM Config menu.
	MFL.Config.Initialize()
	
	--Initialize the MainFrame controls.
	MFL.UI.MainFrame.Initialize()
	
	--Initialize the MsgFrame controls.
	MFL.UI.MsgFrame.Initialize()
	
end

function MFL.Update(force)
	if(not IsReticleHidden() and MFL.UI.MsgFrame.isShowing == true) then
		--Turn the msg frame off.
		MFL.UI.MsgFrame.isShowing = false
		MFL.UI.MsgFrame.top:SetHidden(true)
	end
	force = force or false
	if not DelayedBuffer("delayUpdate", 2.0) then 
		if force == false then return end 
	end

	MFL.PlayerList.Update()
	MFL.UI.MainFrame.Update()
	MFL.UI.MsgFrame.Update()
end

function MFL.OnFriendClicked(friend)
	if friend == "" or friend == nil then return end
	MFL.lastFriendClicked = friend
	if(IsShiftKeyDown()) then
		--Send a tell.
		StartChatInput("/tell " .. MFL.lastFriendClicked .. " ")
		StartChatInput("/tell " .. MFL.lastFriendClicked .. " ")
	else
		--Show the player info frame.
		MFL.UI.MsgFrame.isShowing = true
		MFL.UI.MsgFrame.Update()
	end
end

function MFL.OnGroupInvitation()
	local inviterDisplayName, secsSinceRequest = GetGroupInviteInfo()

	--Cycle through ALL friends.
	for i = 1, GetNumFriends(), 1 do
		local displayName, note, playerStatus, secsSinceLogoff = GetFriendInfo(i)
		local hasCharacter, characterName, zoneName, classType, alliance, level, veteranRank = GetFriendCharacterInfo(i)
		local regularCharacterName = characterName:match("([^^]+)^([^^]+)")
		local uniqueCharacterName = GetUniqueNameForCharacter(characterName)
		
		if(inviterDisplayName == regularCharacterName) then
			AcceptGroupInvite()
			d(MFL.name .. ": Accepted group invitation from - " .. displayName)
			break
		end
	end
end

function MFL.OnInviteToGroup()
	d(MFL.name .. ": Attempting to invite " .. MFL.lastFriendClicked .. " to group.")
	GroupInviteByName(MFL.lastFriendClicked)
end

function MFL.OnTeleportToPlayer()
	d(MFL.name .. ": Attempting Teleport to friend: " .. MFL.lastFriendClicked .. ".")
	JumpToFriend(MFL.lastFriendClicked)
end

--Hook initialization.
EVENT_MANAGER:RegisterForEvent(MFL.name, EVENT_ADD_ON_LOADED, MFL.Initialize)