
MFL.PlayerList = {}
MFL.PlayerList.Sorted = {}
MFL.PlayerList.Online = {}
MFL.PlayerList.Offline = {}


function MFL.PlayerList.Update()
	MFL.PlayerList.Online = {}
	MFL.PlayerList.Offline = {}
	MFL.PlayerList.Sorted = {}
	
	--Cycle through ALL friends.
	for i = 1, GetNumFriends(), 1 do
		local displayName, note, playerStatus, secsSinceLogoff = GetFriendInfo(i)
		local hasCharacter, characterName, zoneName, classType, allianceType, level, veteranRank = GetFriendCharacterInfo(i)
		local className = MFL.PlayerList.GetClassNameByType(classType)
		local allianceName = MFL.PlayerList.GetAllianceNameByType(allianceType)
		local resolvedCharacterName = MFL.PlayerList.ResolveCharacterName(characterName)
		local timeSinceLogoff = nil
		if secsSinceLogoff > 0 then
			timeSinceLogoff = MFL.PlayerList.FormatSecondsToDDHHMMSS(secsSinceLogoff)
		end
		
		--Check if player is online. Add it to the total.
		if(playerStatus == 1) then 
			--Insert these values into the online player list.
			MFL.PlayerList.Online[#MFL.PlayerList.Online + 1]                = {}   --Create new row.
			MFL.PlayerList.Online[#MFL.PlayerList.Online]["displayName"]     = displayName
			MFL.PlayerList.Online[#MFL.PlayerList.Online]["note"]            = note
			MFL.PlayerList.Online[#MFL.PlayerList.Online]["playerStatus"]    = playerStatus
			MFL.PlayerList.Online[#MFL.PlayerList.Online]["timeSinceLogoff"] = timeSinceLogoff
			MFL.PlayerList.Online[#MFL.PlayerList.Online]["characterName"]   = resolvedCharacterName
			MFL.PlayerList.Online[#MFL.PlayerList.Online]["zoneName"]        = zoneName
			MFL.PlayerList.Online[#MFL.PlayerList.Online]["className"]       = className
			MFL.PlayerList.Online[#MFL.PlayerList.Online]["alliance"]        = allianceName
			MFL.PlayerList.Online[#MFL.PlayerList.Online]["level"]           = level
			MFL.PlayerList.Online[#MFL.PlayerList.Online]["veteranRank"]     = veteranRank
		else
			--Insert these values into the offline player list.
			MFL.PlayerList.Offline[#MFL.PlayerList.Offline + 1]                = {}   --Create new row.
			MFL.PlayerList.Offline[#MFL.PlayerList.Offline]["displayName"]     = displayName
			MFL.PlayerList.Offline[#MFL.PlayerList.Offline]["note"]            = note
			MFL.PlayerList.Offline[#MFL.PlayerList.Offline]["playerStatus"]    = playerStatus
			MFL.PlayerList.Offline[#MFL.PlayerList.Offline]["timeSinceLogoff"] = timeSinceLogoff
			MFL.PlayerList.Offline[#MFL.PlayerList.Offline]["characterName"]   = resolvedCharacterName
			MFL.PlayerList.Offline[#MFL.PlayerList.Offline]["zoneName"]        = zoneName
			MFL.PlayerList.Offline[#MFL.PlayerList.Offline]["className"]       = className
			MFL.PlayerList.Offline[#MFL.PlayerList.Offline]["alliance"]        = allianceName
			MFL.PlayerList.Offline[#MFL.PlayerList.Offline]["level"]           = level
			MFL.PlayerList.Offline[#MFL.PlayerList.Offline]["veteranRank"]     = veteranRank
		end
	end
	--Merge the offline and offline lists.
	local ii = 0
	--Merge the online.
	for i = 1, #MFL.PlayerList.Online, 1 do
		ii = ii + 1
		MFL.PlayerList.Sorted[ii] = MFL.PlayerList.Online[i]
	end
	
	--Merge the offline.
	for i = 1, #MFL.PlayerList.Offline, 1 do
		ii = ii + 1
		MFL.PlayerList.Sorted[ii] = MFL.PlayerList.Offline[i]
	end
end


function MFL.PlayerList.FormatSecondsToDDHHMMSS(secsSinceLogoff)
	local days = math.floor(secsSinceLogoff / 86400)
	local hours = math.floor((secsSinceLogoff / 3600) - (days * 24))
	local minutes = math.floor((secsSinceLogoff / 60) - (days * 1440) - (hours * 60))
	local seconds = secsSinceLogoff % 60
	return string.format("%4d Days: %2d Hours: %2d Minutes: %2d Seconds", days, hours, minutes, seconds)
end

function MFL.PlayerList.GetAllianceNameByType(alliance)
	local allianceName = ""
	if alliance == 1 then
		allianceName = "Aldmeri Dominion"
	elseif alliance == 2 then
		allianceName = "Ebonheart Pact"
	elseif alliance == 3 then
		allianceName = "Daggerfall Covenant"
	end
	return allianceName
end

function MFL.PlayerList.ResolveCharacterName(name)
	local resolvedCharacterName = name:match("([^^]+)^([^^]+)")
	return resolvedCharacterName
end

function MFL.PlayerList.GetClassNameByType(ctype)
	local className = ""
	if ctype == 1 then
		className = "Dragonknight"
	elseif ctype == 2 then
		className = "Sorcerer"
	elseif ctype == 3 then
		className = "Nightblade"
	elseif ctype == 6 then
		className = "Templar"
	end
	return className
end

