
local LibUI = LibStub('LibUI-0.1')
if ( not LibUI ) then return end


MFL.UI.MsgFrame           = {}
MFL.UI.MsgFrame.name      = "_MsgFrame"
MFL.UI.MsgFrame.isShowing = false

function MFL.UI.MsgFrame.Initialize()
	local msg = LibUI:CreateTopLevelWindow(MFL.name .. MFL.UI.MsgFrame.name, GuiRoot, {600, 120}, {CENTER, CENTER}, {0, 450}, true)	
	--msg.backdrop = LibUI:CreateBackdrop(MFL.name .. "MSG_BACKDROP", msg, {600, 120}, {CENTER, CENTER}, {0, 0}, {0.05, 0.05, 0.05, 0.8}, {0, 0, 0, 0.8}, false) 
	msg.backdrop = LibUI:CreateBackdropFromVirtual("MSG_BACKDROP", msg, "ZO_DefaultBackdrop")
	
	
	local label = LibUI:CreateLabel(MFL.name .. "_LABEL", msg, {600, 120}, {CENTER, CENTER}, {0, 0}, MFL.savedVars.font, nil, nil, "", false)
	label:SetFont("ZoFontAnnounceMedium")
	
	local btnTeleport = LibUI:CreateButton(MFL.name .. "_BUTTON_TELEPORT", msg, {300, 25}, {CENTER, CENTER}, {0, 0}, nil, nil, nil, nil, nil, nil, false)
	btnTeleport.backdrop = LibUI:CreateBackdrop(MFL.name .. "BUTTON_TELEPORT_BACKDROP", btnTeleport, {300, 25}, {CENTER, CENTER}, {0, 0}, {0.02, 0.02, 0.02, 0.95}, {0.2, 0.2, 0.2, 0.8}, false) 
	--btnTeleport.backdrop = LibUI:CreateBackdropFromVirtual("BUTTON_TELEPORT_BACKDROP", btnTeleport, "ZO_DefaultBackdrop")
	btnTeleport:SetText("TELEPORT TO PLAYER")
	btnTeleport:SetSimpleAnchor(msg, 0, -25)
    btnTeleport:SetHandler("OnMouseUp", function() MFL.OnTeleportToPlayer() end)
	
	local btnGroupInvite = LibUI:CreateButton(MFL.name .. "_BUTTON_GROUP_INVITE", msg, {300, 25}, {CENTER, CENTER}, {0, 0}, nil, nil, nil, nil, nil, nil, false)
	btnGroupInvite.backdrop = LibUI:CreateBackdrop(MFL.name .. "BUTTON_GROUP_INVITE_BACKDROP", btnGroupInvite, {300, 25}, {CENTER, CENTER}, {0, 0}, {0.02, 0.02, 0.02, 0.95}, {0.2, 0.2, 0.2, 0.8}, false) 
	--btnGroupInvite.backdrop = LibUI:CreateBackdropFromVirtual("BUTTON_GROUP_INVITE_BACKDROP", btnGroupInvite, "ZO_DefaultBackdrop")
	btnGroupInvite:SetText("SEND GROUP INVITE")
	btnGroupInvite:SetSimpleAnchor(msg, 300, -25)
    btnGroupInvite:SetHandler("OnMouseUp", function() MFL.OnInviteToGroup() end)
	
	msg.label = label
	msg.btnTeleport = btnTeleport
	msg.btnGroupInvite = btnGroupInvite
	
	MFL.UI.MsgFrame.top = msg
end

function MFL.UI.MsgFrame.Update()
	if MFL.UI.MsgFrame.isShowing == false then return end
	
	--We are showing the frame now.		
	MFL.UI.MsgFrame.top:SetHidden(false)
		
	for i = 1, #MFL.PlayerList.Sorted, 1 do
		if MFL.lastFriendClicked == MFL.PlayerList.Sorted[i]["displayName"] then
			--This index (i) is the player we want.
			local str = MFL.PlayerList.Sorted[i]["displayName"] .. " - " .. MFL.PlayerList.Sorted[i]["characterName"]
			if MFL.PlayerList.Sorted[i]["playerStatus"] == 1 then
				--Online
				MFL.UI.MsgFrame.top.label:SetColor(0.0, 0.6, 0.8, 0.95)
				str = str .. "\nOnline in " .. MFL.PlayerList.Sorted[i]["zoneName"] .. ", "
			else
				--Offline
				MFL.UI.MsgFrame.top.label:SetColor(0.5, 0.5, 0.5, 0.95)
				str = str .. "\nOffline for" .. MFL.PlayerList.Sorted[i]["timeSinceLogoff"] .. "\nLast seen in " .. MFL.PlayerList.Sorted[i]["zoneName"] .. ", " 
			end
			if MFL.PlayerList.Sorted[i]["level"] == 50 then
				--Veteran
				str = str .. "Veteran " .. MFL.PlayerList.Sorted[i]["veteranRank"]
			else
				--Non-Veteran
				str = str .. "Level " .. MFL.PlayerList.Sorted[i]["level"]
			end				
			str = str .. " " .. MFL.PlayerList.Sorted[i]["className"] .. "\n" .. MFL.PlayerList.Sorted[i]["alliance"]
			
			MFL.UI.MsgFrame.top.label:SetText(str)
		end
	end
end
	